//
// Soap bubble fragment shader
//

uniform sampler1D 	fringeMap;
uniform	samplerCube	reflectionMap;

uniform	float	time;
varying float	viewDepth;
varying	vec3	pos;
varying	vec3	v;
varying	vec3	r;
varying	vec3	fresnel;

void main()
{
	float	depthScale = 0.4;

    					// lookup fringe value based on view depth
    	vec3 fringeColor = texture1D ( fringeMap, viewDepth * depthScale ).rgb;

						// lookup reflection in cube map
	vec3	reflColor = textureCube ( reflectionMap, r ).rgb;

    					// modulate reflection by fringe color
	gl_FragColor = vec4 ( reflColor * fringeColor, 0.4 );

//	gl_FragColor = vec4 ( lerp ( fringeColor, reflColor, fresnel ), 0.4 );
}
