//
// Refractive glass fragment shader
//

uniform samplerCube envMap;

varying vec3  n;
varying vec3  e;

void main (void)
{
	const float	eta = 0.9;

    					// Compute reflection vector
  	vec3	en = normalize ( e );
  	vec3	nn = normalize ( n );
    vec3	r  = reflect   ( en, nn );

    					// Do a lookup into the environment map.
    vec3 envColor = textureCube ( envMap, r ).rgb;

    					// calc fresnels term.  This allows a view dependant
    					// blend of reflection/refraction
    float fresnel = abs ( dot ( en, nn ) );

    fresnel =  clamp ( fresnel, 0.1, 0.9 );

						// calc refraction (transmitted ray)
	vec3 	t  = refract ( en, nn, eta );

    vec3 	refractionColor = textureCube ( envMap, t ).rgb;

    envColor = mix ( envColor, refractionColor, fresnel );

    gl_FragColor = vec4 ( envColor, 1.0 );
}