//
// Refractive glass vertex shader
//
uniform	vec4	eyePos;
uniform	mat4	cubeMapMatrix;

varying vec3  n;
varying vec3  e;

void main(void)
{
    vec4 	pos = gl_ModelViewMatrix * gl_Vertex;

	gl_Position = gl_ModelViewProjectionMatrix * gl_Vertex;
    n           = normalize ( gl_NormalMatrix * gl_Normal * mat3 ( cubeMapMatrix [0].xyz, cubeMapMatrix [1].xyz, cubeMapMatrix [2].xyz ) );
    e           = normalize ( ( ( pos - eyePos )*cubeMapMatrix ).xyz );
}