//
// Simple particle system vertex shader
//

uniform		float	time;
varying		vec3	pos;

void main(void)
{
	vec3	vel   = 3.0 * gl_MultiTexCoord1.xyz;
	vec3	pos   = gl_Vertex.xyz;
	float	phase = gl_MultiTexCoord1.w;
	float	t     = mod ( time + phase, 4.0 );

											// now compute new position using t and org
	vec3	org = pos + t*vel - 0.5*t*t*vec3 ( 0.0, 0.0, 1.0 );

	pos             = org;
	gl_Position     = gl_ModelViewProjectionMatrix * vec4 ( org, 1.0 );
	gl_TexCoord [0] = gl_MultiTexCoord0;
	gl_PointSize    = 1.0 + 3.0 * t;
}
