//
// Soap bubble fragment shader with animated noise
//

uniform sampler1D 	fringeMap;
uniform	samplerCube	reflectionMap;
uniform sampler3D 	noiseMap;

uniform	float	time;
varying float	viewDepth;
varying	vec3	pos;
varying	vec3	v;
varying	vec3	r;
varying	vec3	fresnel;

void main()
{
						// get noise to adjust viewDepth
	vec3	ncoord     = vec3 ( pos.x, pos.y + time, pos.z ) * 0.3;
	vec3	noise      = texture3D ( noiseMap, ncoord ).rgb;
	float	depthScale = (1.0 + noise.r)*0.4;

    					// lookup fringe value based on view depth
    vec3 fringeColor = texture1D ( fringeMap, viewDepth * depthScale ).rgb;

						// lookup reflection in cube map
	vec3	reflColor = textureCube ( reflectionMap, r ).rgb;

    					// modulate reflection by fringe color
	gl_FragColor = vec4 ( reflColor * fringeColor, 0.4 );

//	gl_FragColor = vec4 ( lerp ( fringeColor, reflColor, fresnel ), 0.4 );
}
