//
// Soap bubble vertex shader
//

uniform vec4	eyePos;
uniform	vec3	r0;								// components for R, G and B

varying float	viewDepth;
varying	vec3	pos;
varying	vec3	v;
varying	vec3	r;
varying	vec3	fresnel;

void main()
{
	const	float	filmDepth = 0.1;
	const	vec3	one       = vec3 ( 1.0 );


    gl_Position = ftransform ();				// transform position to clip space

												// transformed point to world space
	vec3	p = vec3 ( gl_ModelViewMatrix * gl_Vertex );

    											// transform normal from model-space to view-space
    vec3	n = normalize ( gl_NormalMatrix * gl_Normal );

    v         = normalize ( eyePos.xyz - p ); 	// compute the vertex to eye vector
    r         = reflect   ( v, n );
    viewDepth = filmDepth / dot ( n, v );		// compute the view depth for the thin film
    pos       = gl_Vertex.xyz;
    											// compute approximation to Fresnel
	fresnel   = r0 + (one - r0) * pow ( 1.0 - abs ( dot ( n,v ) ), 5.0 );

				    							// output texture coordinates for diffuse map
    gl_TexCoord [0] = gl_MultiTexCoord0;
}
