//
// Simple noise-based bump mapping
//

varying	vec3 l;
varying	vec3 h;
varying vec3 v;
varying vec3 n;
varying	vec3 pp;

uniform sampler3D	noiseMap;

void main (void)
{
	const vec4	diffColor = vec4 ( 0.5, 0.0, 0.0, 1.0 );
	const vec4	specColor = vec4 ( 0.7, 0.7, 0.0, 1.0 );
	const float	specPower = 30.0;

	vec3	n2   = normalize ( n + 2.0*texture3D ( noiseMap, 2.0*pp ).rgb - vec3 ( 1.0 ) );
	vec3	l2   = normalize ( l );
	vec3	h2   = normalize ( h );
	vec4	diff = diffColor * max ( dot ( n2, l2 ), 0.0 );
	vec4	spec = specColor * pow ( max ( dot ( n2, h2 ), 0.0 ), specPower );

	gl_FragColor = diff + spec;
}
