//
// Simple sky vertex shader
//
// Author: Alex V. Boreskoff
//

varying	vec3 v;
varying	vec3 l;
varying	vec3 pos;

uniform	vec4 sunPos;
uniform	vec4 eyePos;

void main(void)
{
	vec3	p = vec3 ( gl_ModelViewMatrix * gl_Vertex );

	v   = vec3 ( gl_ModelViewMatrix * eyePos ) - p;
	l   = vec3 ( gl_ModelViewMatrix * sunPos ) - p;
	pos = 0.1 * gl_Vertex.xyz;

	gl_Position     = gl_ModelViewProjectionMatrix * gl_Vertex;
	gl_TexCoord [0] = gl_MultiTexCoord0;
}
