//
// Rippled water vertex shader
//
uniform	vec4	eyePos;

varying vec3  n;
varying vec3  e;
varying	vec3  p;

void main(void)
{
								// we have to compensate for texture coordinate transform
    mat3	rot = mat3 ( 1, 0,  0,
                         0, 0, 1, 
                         0, -1,  0 );

    vec3 	pos = vec3 ( gl_ModelViewMatrix * gl_Vertex );

	gl_Position = gl_ModelViewProjectionMatrix * gl_Vertex;
    n           =  normalize ( gl_NormalMatrix * gl_Normal ) * rot;
    e           =  rot * normalize ( eyePos.xyz - gl_Vertex.xyz );
    p           = gl_Vertex.xyz;
}