#include	"nv_util.h"
#include	<stdio.h>
#include	<glut.h>
#include	<math.h>
#include	"Vector3D.h"
#include	"boxes.h"

float	angle  = 0.0f;
float	angle2 = 0.0f;
float	d      = 3.0f / (float)sqrt ( 3 );
unsigned	texId = 0;

using namespace tga;

unsigned loadTga ( const char * fileName )
{
	tgaImage * im = read ( fileName );

	if ( im == NULL )
		return 0;

	unsigned    textureId;

	glGenTextures   ( 1, &textureId );
	glBindTexture   ( GL_TEXTURE_2D, textureId );
	glPixelStorei   ( GL_UNPACK_ALIGNMENT, 1 );                         // set 1-byte alignment

	glTexParameteri ( GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT );    // set texture to repeat mode
	glTexParameteri ( GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT );

    gluBuild2DMipmaps ( GL_TEXTURE_2D, im -> components, im -> width, 
                            im -> height, im -> format, GL_UNSIGNED_BYTE, 
                            im -> pixels );

	glTexParameteri ( GL_TEXTURE_1D, GL_TEXTURE_MAG_FILTER, GL_LINEAR );
	glTexParameteri ( GL_TEXTURE_1D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR );

	free ( im -> pixels );
	free ( im           );

	return textureId;
}

void init ()
{
	glClearColor  ( 0.0, 0.0, 0.0, 1.0 );
	glEnable      ( GL_DEPTH_TEST );
	glEnable      ( GL_TEXTURE_2D );
	glPixelStorei ( GL_PACK_ALIGNMENT, 1 );
	glPixelStorei ( GL_UNPACK_ALIGNMENT, 1 );
}

void	animate ()
{
	angle  += 0.75f;	// * glutGet ( GLUT_ELAPSED_TIME );
	angle2 += 0.1f;

	glutPostRedisplay ();
}

void display ()
{
	glClear ( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );

    glMatrixMode   ( GL_MODELVIEW );
    glLoadIdentity ();
    gluLookAt      ( 0, 0, 0,		// eye
	 				 1, 1, 1,		// center
					 0, 1, 0 );		// up


	glTranslatef ( 4, 4, 4 );
	glRotatef    ( angle2, 1, -1, 0 );
	glTranslatef ( d - 1.5f, d - 1.5f, d - 1.5f );

	glTranslatef ( 1.5f, 1.5f, 1.5f );			// move cube from the center
	glRotatef    ( angle, 1.0f, 1.0f, 0.0f );
	glTranslatef ( -1.5f, -1.5f, -1.5f );		// move cube into the center

//	drawBox ( 1, 2, 1, 2, 1, 2 );
	drawBox ( Vector3D ( -1, -1, -1 ), Vector3D ( 2, 2, 2 ), texId );
	
	glutSwapBuffers ();
}

void reshape ( int w, int h ) 
{
   glViewport     ( 0, 0, (GLsizei)w, (GLsizei)h );
   glMatrixMode   ( GL_PROJECTION );
   glLoadIdentity ();
   gluPerspective ( 60.0, (GLfloat)w/(GLfloat)h, 1.0, 60.0 );

   glMatrixMode   ( GL_MODELVIEW );
   glLoadIdentity ();
   gluLookAt      ( 0.0, 0.0, 0.0,		// eye
					1.0, 1.0, 1.0,		// center
					0.0, 1.0, 0.0 );
}

void key ( unsigned char key, int x, int y )
{
	if ( key == 27 || key == 'q' || key == 'Q' )		//quit requested
		exit ( 0 );
}

int main ( int argc, char ** argv )
{
								//initialise glut
	glutInit            ( &argc, argv );
	glutInitDisplayMode ( GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH );   
	glutInitWindowSize  ( 600, 600 );

								// create window
	glutCreateWindow ( "TGA loading example" );

	init ();
								// register handlers
	glutDisplayFunc  ( display );
	glutReshapeFunc  ( reshape );
    glutKeyboardFunc ( key     );
	glutIdleFunc     ( animate );

								// load texture
	texId = loadTga ( "..\\..\\Textures\\wall.tga" );
	
	glutMainLoop ();

	return 0;
}

