//--------------------------------------------------------------
//                     OpenGL Camera Control Demo
// Author: Roman Podobedov
// Email: romka@ut.ee
// WEB: http://romka.demonews.com
//--------------------------------------------------------------

// Camera control class
class CCamera
{

public:

	CCamera();
	virtual ~CCamera();

	void SetCameraPos(float x, float y, float z); // Set camera position
	void SetCameraTargetPos(float x, float y, float z); // Set target camera position
	void SetMouse(int mx, int my, int WinWidth, int WinHeight); // Send mouse parameters from mouse

	void IncSpeed(float speed);
	void DecSpeed(float speed);
	
	void SetCamera(); // Set current model view matrix, view from camera

	void GetNewCoord(float *x, float *y, float *z); // Get new coordinates of the camera
	void Move(); // Move the camera

protected:

	float m_x, m_y, m_z; // Camera x, y, z coordinates
	float m_tx, m_ty, m_tz; // Camera target x, y, z coordinates
	
	float speed_a, speed_b; // Camera rotate speed by axis a and b
	float angle_a, angle_b; // Rotating angles a, b
	float last_angle_a, last_angle_b;
	float old_angle_a, old_angle_b; // Rotating angles a, b

	float m_speed;
	float l_x, l_y, l_z;

	float new_x, new_y, new_z; // New coordinates of the camera

};