// cam.h
#include <GL/glut.h>
#include <stdio.h>
#include <stdlib.h>

void VectorMatrixMult(GLfloat a[3],  const GLfloat b[3][3], GLfloat c[3]); 
void MatrixMult(GLfloat a[3][3],  const GLfloat b[3][3], GLfloat r[3][3]); 

typedef enum {X_AXIS, Y_AXIS, Z_AXIS} axis;

class Camera {
  public:
    Camera() {eye[0] = 0.0f; eye[1] = 0.0f; eye[2] = 0.0f;
              up[0] = 0.0f; up[1] = 1.0f; up[2] = 0.0f;
              side[0] = 1.0f; side[1] = 0.0f; side[2] = 0.0f;
              look[0] = 0.0f; look[1] = 0.0f; look[2] = -1.0f;
              Translate(0.0f, 6.0f, 10.0f); };
    void Rotate(GLfloat angle, axis axe);
    void Translate(GLfloat x, GLfloat y, GLfloat z);
    void Update_glMatrix();
    void DebugPrint();

    // orthogonal base of the camera
    GLfloat eye[3];
    GLfloat up[3];
    GLfloat side[3];// right side
    GLfloat look[3];// in the negative z-axis
};  // class Camera

///////////////////////////////////// eof //////////////////////////////////////
